{Copyright (C) 1985 Adam Fritz, 133 Main St., Afton, NY 13730}

program main ;
     {                                                     }
     { Program: LINPACK SGECO and SGEDI Test Driver.       }
     {                                                     }
     { Version: 1.0/T           Date: 02/22/85             }
     {                                                     }
     { Description:                                        }
     {                                                     }
     {    Uses LINPACK SGECO to compute RCond for matrix   }
     {    A and LINPACK SGEDI to compute determinant and   }
     {    inverse of matrix A where A is set up as a       }
     {    Hilbert matrix of specified order using SYSGEN.  }
     {    Uses SGEFA and SGEDI to invert inverse to com-   }
     {    with original.                                   }
     {                                                     }
     { Author:                                             }
     {                                                     }
     {    Adam Fritz                                       }
     {    133 Main Street                                  }
     {    Afton, New York 13730                            }
     {                                                     }

{$I LINPACK.con                 CONSTANT Declarations      }
{$I LINPACK.typ                 TYPE Declarations          }
{$I LINPACK.var                 VARIABLE Declarations      }

     i, j           : integer ;
     AA             : MATRIX ;
     P              : MATRIX ;

{$I Hilgen.pas                  Test System Generator      }
{$I BLAS.pas                    Basic Linear Algebra       }
{$I SGEFA.pas                   LINPACK Factor             }
{$I SGECO.pas                   LINPACK Condition          }
{$I SGEDI.pas                   LINPACK Determinant and    }
{                                  Inverse                 }
{$I OUT.pas                     SICE Output Routine        }

begin
                                { Initialize }
   writeln('LINPACK SGECO and SDEDI Test Program.') ;
   writeln ;
                                { Get Order }
   n := 0 ;
   while (n < 1) or (n > lda) do begin
      write('Order: ') ;
      readln(n)
   end ;
                                { Get Print Code }
   write('Print Code: ') ;
   readln (PrintCode) ;
                                { Generate Test System }
   SYSGEN(A, lda, n, b) ;
   if PrintCode > 0 then begin
      writeln ;
      writeln('Original System (by column):') ;
      writeln ;
      OUT(A[1,1], lda, n, n) ;
      OUT(b[1], lda, n, 1)
   end ;
                                { Copy Original by Rows }
   for i := 1 to n do
      SCOPY(n, A[i,1], 1, AA[i,1], 1) ;
                                { Compute Condition }
   SGECO(A, lda, n, IPvt, RCond, Work) ;
   if PrintCode > 0 then begin
      writeln ;
      write('RCond: ',RCond:14) ;
      writeln(', RCond: ',((1.0+RCond)-1.0):14) ;
      writeln
   end ;
                                { Compute Determinant and Inverse }
   if RCond <> 0.0 then begin
      JobCode := 11 ;
      SGEDI(A, lda, n, IPvt, Det, Work, JobCode) ;
      if PrintCode > 0 then begin
         writeln ;
         writeln('Inverse (by column):') ;
         writeln ;
         OUT(A[1,1], lda, n, n) ;
         writeln('Determinant: ',Det[1]:14:8,'E',Det[2]:3:0)
      end ;
                                { Original Times Inverse }
      for i := 1 to n do
         for j := 1 to n do
            P[i,j] := SDOT(n, AA[i,1], 1, A[1,j], lda) ;
      if PrintCode > 0 then begin
         writeln ;
         writeln('Original times Inverse (by column):') ;
         writeln ;
         OUT(P[1,1], lda, n, n)
      end ;
                                { Try to Restore Original }
      SGEFA(A, lda, n, IPvt, InfoCode) ;
      if InfoCode = 0 then begin
         SGEDI(A, lda, n, IPvt, Det, Work, JobCode) ;
         if PrintCode > 0 then begin
            writeln ;
            writeln('Inverse of Inverse (by column):') ;
            writeln ;
            OUT(A[1,1], lda, n, n)
         end
      end
      else
         writeln('Error: Inverse is Singular.')
   end
                                { Zero Diagonal Element Produced }
   else
      writeln('Error: Original is Singular.') ;
                                { Done }
   writeln('End of Test.')

end.

{Copyright (C) 1985 Adam Fritz, 133 Main St., Afton, NY 13730}
